/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// UserApplicationSubscriptionStatus the model 'UserApplicationSubscriptionStatus'
type UserApplicationSubscriptionStatus string

// List of UserApplicationSubscriptionStatus
const (
	USERAPPLICATIONSUBSCRIPTIONSTATUS_UNDEFINED    UserApplicationSubscriptionStatus = "Undefined"
	USERAPPLICATIONSUBSCRIPTIONSTATUS_DENIED       UserApplicationSubscriptionStatus = "Denied"
	USERAPPLICATIONSUBSCRIPTIONSTATUS_NOT_ELIGIBLE UserApplicationSubscriptionStatus = "NotEligible"
	USERAPPLICATIONSUBSCRIPTIONSTATUS_ELIGIBLE     UserApplicationSubscriptionStatus = "Eligible"
	USERAPPLICATIONSUBSCRIPTIONSTATUS_SUBSCRIBED   UserApplicationSubscriptionStatus = "Subscribed"
	USERAPPLICATIONSUBSCRIPTIONSTATUS_INVALID      UserApplicationSubscriptionStatus = "Invalid"
)

// All allowed values of UserApplicationSubscriptionStatus enum
var AllowedUserApplicationSubscriptionStatusEnumValues = []UserApplicationSubscriptionStatus{
	"Undefined",
	"Denied",
	"NotEligible",
	"Eligible",
	"Subscribed",
	"Invalid",
}

func (v *UserApplicationSubscriptionStatus) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := UserApplicationSubscriptionStatus(value)
	for _, existing := range AllowedUserApplicationSubscriptionStatusEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid UserApplicationSubscriptionStatus", value)
}

// NewUserApplicationSubscriptionStatusFromValue returns a pointer to a valid UserApplicationSubscriptionStatus
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewUserApplicationSubscriptionStatusFromValue(v string) (*UserApplicationSubscriptionStatus, error) {
	ev := UserApplicationSubscriptionStatus(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for UserApplicationSubscriptionStatus: valid values are %v", v, AllowedUserApplicationSubscriptionStatusEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v UserApplicationSubscriptionStatus) IsValid() bool {
	for _, existing := range AllowedUserApplicationSubscriptionStatusEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to UserApplicationSubscriptionStatus value
func (v UserApplicationSubscriptionStatus) Ptr() *UserApplicationSubscriptionStatus {
	return &v
}

type NullableUserApplicationSubscriptionStatus struct {
	value *UserApplicationSubscriptionStatus
	isSet bool
}

func (v NullableUserApplicationSubscriptionStatus) Get() *UserApplicationSubscriptionStatus {
	return v.value
}

func (v *NullableUserApplicationSubscriptionStatus) Set(val *UserApplicationSubscriptionStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableUserApplicationSubscriptionStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableUserApplicationSubscriptionStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserApplicationSubscriptionStatus(val *UserApplicationSubscriptionStatus) *NullableUserApplicationSubscriptionStatus {
	return &NullableUserApplicationSubscriptionStatus{value: val, isSet: true}
}

func (v NullableUserApplicationSubscriptionStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserApplicationSubscriptionStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
